;--------------------------------------------------------
; File Created by SDCC : free open source ANSI-C Compiler
; Version 3.6.8 #9946 (CYGWIN)
;--------------------------------------------------------
	.module teopl_ringbuffer
	.optsdcc -mz80
	
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _teopl_ringbuffer_init
	.globl _teopl_ringbuffer_index_get
	.globl _teopl_ringbuffer_add
	.globl _teopl_ringbuffer_remove
	.globl _teopl_ringbuffer_peek
	.globl _teopl_ringbuffer_pull
	.globl _teopl_ringbuffer_is_full
	.globl _teopl_ringbuffer_is_empty
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _DATA
;--------------------------------------------------------
; ram data
;--------------------------------------------------------
	.area _INITIALIZED
;--------------------------------------------------------
; absolute external ram data
;--------------------------------------------------------
	.area _DABS (ABS)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area _HOME
	.area _GSINIT
	.area _GSFINAL
	.area _GSINIT
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area _HOME
	.area _HOME
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area _CODE
;src/teopl_ringbuffer.c:37: void teopl_ringbuffer_init(TeoplRingBuffer* ptr) {
;	---------------------------------
; Function teopl_ringbuffer_init
; ---------------------------------
_teopl_ringbuffer_init::
;src/teopl_ringbuffer.c:39: ptr->index_start = 0;
	pop	de
	pop	bc
	push	bc
	push	de
	xor	a, a
	ld	(bc), a
;src/teopl_ringbuffer.c:40: ptr->index_end = 0;
	ld	e, c
	ld	d, b
	inc	de
	xor	a, a
	ld	(de), a
;src/teopl_ringbuffer.c:41: ptr->num_elements = 0;
	inc	bc
	inc	bc
	xor	a, a
	ld	(bc), a
	ret
;src/teopl_ringbuffer.c:44: u8 teopl_ringbuffer_index_get(TeoplRingBuffer* ptr, TEOPL_MEMORY_POINTER_TYPE input) {
;	---------------------------------
; Function teopl_ringbuffer_index_get
; ---------------------------------
_teopl_ringbuffer_index_get::
	call	___sdcc_enter_ix
	push	af
	push	af
;src/teopl_ringbuffer.c:46: u8 result = TEOPL_RINGBUFFER_LENGTH_MAX;
	ld	e, #0x20
;src/teopl_ringbuffer.c:48: u8 i, num = ptr->num_elements;
	ld	c,4 (ix)
	ld	b,5 (ix)
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	ld	a, (hl)
	ld	-2 (ix), a
;src/teopl_ringbuffer.c:51: for (i = 0; i < num; ++i) {
	ld	-1 (ix), #0x00
	ld	d, #0x00
00106$:
	ld	a, d
	sub	a, -2 (ix)
	jr	NC,00104$
;src/teopl_ringbuffer.c:52: if (teopl_ringbuffer_peek(ptr, i, &output) && input == output) {
	ld	hl, #0x0000
	add	hl, sp
	push	bc
	push	de
	push	hl
	push	de
	inc	sp
	push	bc
	call	_teopl_ringbuffer_peek
	pop	af
	pop	af
	inc	sp
	pop	de
	pop	bc
	ld	a, l
	or	a, a
	jr	Z,00107$
	ld	a, 6 (ix)
	sub	a, -4 (ix)
	jr	NZ,00107$
	ld	a, 7 (ix)
	sub	a, -3 (ix)
	jr	NZ,00107$
;src/teopl_ringbuffer.c:53: result = i;
	ld	e, -1 (ix)
;src/teopl_ringbuffer.c:54: break;
	jr	00104$
00107$:
;src/teopl_ringbuffer.c:51: for (i = 0; i < num; ++i) {
	inc	d
	ld	-1 (ix), d
	jr	00106$
00104$:
;src/teopl_ringbuffer.c:58: return result;
	ld	l, e
	ld	sp, ix
	pop	ix
	ret
;src/teopl_ringbuffer.c:61: u8 teopl_ringbuffer_add(TeoplRingBuffer* ptr, TEOPL_MEMORY_POINTER_TYPE input) {
;	---------------------------------
; Function teopl_ringbuffer_add
; ---------------------------------
_teopl_ringbuffer_add::
	call	___sdcc_enter_ix
	push	af
;src/teopl_ringbuffer.c:65: if (teopl_ringbuffer_is_full(ptr)) {
	ld	l,4 (ix)
	ld	h,5 (ix)
	push	hl
	call	_teopl_ringbuffer_is_full
	pop	af
	ld	a, l
	or	a, a
	jr	Z,00102$
;src/teopl_ringbuffer.c:66: return 0;
	ld	l, #0x00
	jr	00103$
00102$:
;src/teopl_ringbuffer.c:69: index_end = (ptr->index_end + (u8)(teopl_ringbuffer_is_empty(ptr) ? 0 : 1)) % TEOPL_RINGBUFFER_LENGTH_MAX;
	ld	c,4 (ix)
	ld	b,5 (ix)
	ld	hl, #0x0001
	add	hl,bc
	ex	(sp), hl
	pop	hl
	push	hl
	ld	e, (hl)
	ld	d, #0x00
	push	bc
	push	de
	push	bc
	call	_teopl_ringbuffer_is_empty
	pop	af
	pop	de
	pop	bc
	ld	a, l
	or	a, a
	jr	Z,00105$
	ld	l, #0x00
	jr	00106$
00105$:
	ld	l, #0x01
00106$:
	ld	h, #0x00
	add	hl, de
	push	bc
	ld	de, #0x0020
	push	de
	push	hl
	call	__modsint
	pop	af
	pop	af
	ld	e, l
	pop	bc
;src/teopl_ringbuffer.c:71: ptr->buffer[index_end] = input;
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	inc	hl
	ld	a, e
	add	a, a
	add	a,l
	ld	l, a
	ld	a, h
	adc	a, #0x00
	ld	h, a
	ld	a, 6 (ix)
	ld	(hl), a
	inc	hl
	ld	a, 7 (ix)
	ld	(hl), a
;src/teopl_ringbuffer.c:73: ptr->index_end = index_end;
	pop	hl
	push	hl
	ld	(hl), e
;src/teopl_ringbuffer.c:75: ptr->num_elements++;
	inc	bc
	inc	bc
	ld	a, (bc)
	inc	a
	ld	(bc), a
;src/teopl_ringbuffer.c:77: return 1;
	ld	l, #0x01
00103$:
	pop	af
	pop	ix
	ret
;src/teopl_ringbuffer.c:81: u8 teopl_ringbuffer_remove(TeoplRingBuffer* ptr, TEOPL_MEMORY_POINTER_TYPE input) {
;	---------------------------------
; Function teopl_ringbuffer_remove
; ---------------------------------
_teopl_ringbuffer_remove::
	call	___sdcc_enter_ix
	ld	hl, #-75
	add	hl, sp
	ld	sp, hl
;src/teopl_ringbuffer.c:83: u8 i, num, found = 0;
	ld	-4 (ix), #0x00
;src/teopl_ringbuffer.c:87: teopl_ringbuffer_init(&tmp);
	ld	hl, #0x0002
	add	hl, sp
	ex	de,hl
	ld	c, e
	ld	b, d
	push	de
	push	bc
	call	_teopl_ringbuffer_init
	pop	af
	pop	de
;src/teopl_ringbuffer.c:89: num = ptr->num_elements;
	ld	c,4 (ix)
	ld	b,5 (ix)
	ld	l, c
	ld	h, b
	inc	hl
	inc	hl
	ld	a, (hl)
	ld	-1 (ix), a
;src/teopl_ringbuffer.c:90: for (i = 0; i < num; ++i) {
	ld	-3 (ix), e
	ld	-2 (ix), d
	ld	-74 (ix), #0x00
00110$:
	ld	a, -74 (ix)
	sub	a, -1 (ix)
	jr	NC,00105$
;src/teopl_ringbuffer.c:91: if (teopl_ringbuffer_peek(ptr, i, &output) && input != output) {
	ld	hl, #0x0045
	add	hl, sp
	push	bc
	push	de
	push	hl
	ld	a, -74 (ix)
	push	af
	inc	sp
	push	bc
	call	_teopl_ringbuffer_peek
	pop	af
	pop	af
	inc	sp
	pop	de
	pop	bc
	ld	a, l
	or	a, a
	jr	Z,00102$
	ld	a, 6 (ix)
	sub	a, -6 (ix)
	jr	NZ,00147$
	ld	a, 7 (ix)
	sub	a, -5 (ix)
	jr	Z,00102$
00147$:
;src/teopl_ringbuffer.c:92: teopl_ringbuffer_add(&tmp, output);
	push	hl
	ld	l, -3 (ix)
	ld	h, -2 (ix)
	push	hl
	pop	iy
	pop	hl
	push	bc
	push	de
	ld	l,-6 (ix)
	ld	h,-5 (ix)
	push	hl
	push	iy
	call	_teopl_ringbuffer_add
	pop	af
	pop	af
	pop	de
	pop	bc
	jr	00111$
00102$:
;src/teopl_ringbuffer.c:95: found = 1;
	ld	-4 (ix), #0x01
00111$:
;src/teopl_ringbuffer.c:90: for (i = 0; i < num; ++i) {
	inc	-74 (ix)
	jr	00110$
00105$:
;src/teopl_ringbuffer.c:99: teopl_ringbuffer_init(ptr);
	push	bc
	push	de
	push	bc
	call	_teopl_ringbuffer_init
	pop	af
	pop	de
	pop	bc
;src/teopl_ringbuffer.c:101: num--;
	ld	a, -1 (ix)
	add	a, #0xff
	ld	-75 (ix), a
;src/teopl_ringbuffer.c:102: for (i = 0; i < num; ++i) {
	ld	-3 (ix), e
	ld	-2 (ix), d
	ld	e, #0x00
00113$:
	ld	a, e
	sub	a, -75 (ix)
	jr	NC,00108$
;src/teopl_ringbuffer.c:103: if (teopl_ringbuffer_peek(&tmp, i, &output)) {
	ld	iy,#0x0045
	add	iy,sp
	ld	l,-3 (ix)
	ld	h,-2 (ix)
	push	bc
	push	de
	push	iy
	ld	a, e
	push	af
	inc	sp
	push	hl
	call	_teopl_ringbuffer_peek
	pop	af
	pop	af
	inc	sp
	pop	de
	pop	bc
	ld	a, l
	or	a, a
	jr	Z,00114$
;src/teopl_ringbuffer.c:104: teopl_ringbuffer_add(ptr, output);
	push	bc
	push	de
	ld	l,-6 (ix)
	ld	h,-5 (ix)
	push	hl
	push	bc
	call	_teopl_ringbuffer_add
	pop	af
	pop	af
	pop	de
	pop	bc
00114$:
;src/teopl_ringbuffer.c:102: for (i = 0; i < num; ++i) {
	inc	e
	jr	00113$
00108$:
;src/teopl_ringbuffer.c:108: return found;
	ld	l, -4 (ix)
	ld	sp, ix
	pop	ix
	ret
;src/teopl_ringbuffer.c:111: u8 teopl_ringbuffer_peek(TeoplRingBuffer* ptr, u8 index, TEOPL_MEMORY_POINTER_TYPE* output) {
;	---------------------------------
; Function teopl_ringbuffer_peek
; ---------------------------------
_teopl_ringbuffer_peek::
	call	___sdcc_enter_ix
	push	af
	push	af
;src/teopl_ringbuffer.c:113: if (!teopl_ringbuffer_is_empty(ptr) && index <= ptr->num_elements - 1) {
	ld	l,4 (ix)
	ld	h,5 (ix)
	push	hl
	call	_teopl_ringbuffer_is_empty
	pop	af
	ld	a, l
	or	a, a
	jr	NZ,00102$
	ld	e,4 (ix)
	ld	d,5 (ix)
	ld	l, e
	ld	h, d
	inc	hl
	inc	hl
	ld	l, (hl)
	ld	h, #0x00
	dec	hl
	ld	c, 6 (ix)
	ld	b, #0x00
	ld	a, l
	sub	a, c
	ld	a, h
	sbc	a, b
	jp	PO, 00114$
	xor	a, #0x80
00114$:
	jp	M, 00102$
;src/teopl_ringbuffer.c:115: *output = ptr->buffer[((ptr->index_start + index) % TEOPL_RINGBUFFER_LENGTH_MAX)];
	ld	a, 7 (ix)
	ld	-2 (ix), a
	ld	a, 8 (ix)
	ld	-1 (ix), a
	ld	hl, #0x0003
	add	hl,de
	ex	(sp), hl
	ld	a, (de)
	ld	l, a
	ld	h, #0x00
	add	hl, bc
	ld	bc, #0x0020
	push	bc
	push	hl
	call	__modsint
	pop	af
	pop	af
	add	hl, hl
	pop	de
	push	de
	add	hl, de
	ld	c, (hl)
	inc	hl
	ld	b, (hl)
	ld	l,-2 (ix)
	ld	h,-1 (ix)
	ld	(hl), c
	inc	hl
	ld	(hl), b
;src/teopl_ringbuffer.c:117: return 1;
	ld	l, #0x01
	jr	00104$
00102$:
;src/teopl_ringbuffer.c:120: return 0;
	ld	l, #0x00
00104$:
	ld	sp, ix
	pop	ix
	ret
;src/teopl_ringbuffer.c:123: u8 teopl_ringbuffer_pull(TeoplRingBuffer* ptr, TEOPL_MEMORY_POINTER_TYPE* output) {
;	---------------------------------
; Function teopl_ringbuffer_pull
; ---------------------------------
_teopl_ringbuffer_pull::
	call	___sdcc_enter_ix
	push	af
;src/teopl_ringbuffer.c:125: if (!teopl_ringbuffer_is_empty(ptr)) {
	ld	l,4 (ix)
	ld	h,5 (ix)
	push	hl
	call	_teopl_ringbuffer_is_empty
	pop	af
	ld	a, l
	or	a, a
	jr	NZ,00104$
;src/teopl_ringbuffer.c:127: *output = ptr->buffer[ptr->index_start];
	ld	c,6 (ix)
	ld	b,7 (ix)
	ld	a, 4 (ix)
	ld	-2 (ix), a
	ld	a, 5 (ix)
	ld	-1 (ix), a
	pop	de
	push	de
	inc	de
	inc	de
	inc	de
	pop	hl
	push	hl
	ld	l, (hl)
	sla	l
	ld	h,#0x00
	add	hl, de
	ld	e, (hl)
	inc	hl
	ld	d, (hl)
	ld	a, e
	ld	(bc), a
	inc	bc
	ld	a, d
	ld	(bc), a
;src/teopl_ringbuffer.c:129: ptr->num_elements--;
	pop	hl
	push	hl
	inc	hl
	inc	hl
	ld	c, (hl)
	dec	c
	ld	(hl), c
;src/teopl_ringbuffer.c:131: if (!teopl_ringbuffer_is_empty(ptr)) {
	pop	hl
	push	hl
	push	hl
	call	_teopl_ringbuffer_is_empty
	pop	af
	ld	a, l
	or	a, a
	jr	NZ,00102$
;src/teopl_ringbuffer.c:132: ptr->index_start = (ptr->index_start + 1) % TEOPL_RINGBUFFER_LENGTH_MAX;
	pop	hl
	push	hl
	ld	c, (hl)
	ld	b, #0x00
	inc	bc
	ld	hl, #0x0020
	push	hl
	push	bc
	call	__modsint
	pop	af
	pop	af
	ld	c, l
	pop	hl
	push	hl
	ld	(hl), c
00102$:
;src/teopl_ringbuffer.c:135: return 1;
	ld	l, #0x01
	jr	00105$
00104$:
;src/teopl_ringbuffer.c:138: return 0;
	ld	l, #0x00
00105$:
	pop	af
	pop	ix
	ret
;src/teopl_ringbuffer.c:141: u8 teopl_ringbuffer_is_full(TeoplRingBuffer* ptr) {
;	---------------------------------
; Function teopl_ringbuffer_is_full
; ---------------------------------
_teopl_ringbuffer_is_full::
;src/teopl_ringbuffer.c:143: return ptr->num_elements == TEOPL_RINGBUFFER_LENGTH_MAX;
	pop	bc
	pop	hl
	push	hl
	push	bc
	inc	hl
	inc	hl
	ld	a, (hl)
	sub	a, #0x20
	jr	NZ,00103$
	ld	a,#0x01
	jr	00104$
00103$:
	xor	a,a
00104$:
	ld	l, a
	ret
;src/teopl_ringbuffer.c:146: u8 teopl_ringbuffer_is_empty(TeoplRingBuffer* ptr) {
;	---------------------------------
; Function teopl_ringbuffer_is_empty
; ---------------------------------
_teopl_ringbuffer_is_empty::
;src/teopl_ringbuffer.c:148: return !ptr->num_elements;
	pop	bc
	pop	hl
	push	hl
	push	bc
	inc	hl
	inc	hl
	ld	a, (hl)
	sub	a,#0x01
	ld	a, #0x00
	rla
	ld	l, a
	ret
	.area _CODE
	.area _INITIALIZER
	.area _CABS (ABS)
