#!/bin/bash

#-----------------------------LICENSE NOTICE-----------------------------------
#     __    __  ______  __________
#    / /   / / / / __ \/  _/ ____/
#   / /   / / / / / / // // /
#  / /___/ /_/ / /_/ // // /___
# /_____/\____/_____/___/\____/
# (break the loop)
#
# This file is part of Amstrad CPC game "LUDIC break the loop".
#
#  "LUDIC break the loop" is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  "LUDIC break the loop" is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with this program.  If not, see <http:#www.gnu.org/licenses/>.
#
#  Code, Concept, Story Copyright (C) 2019 Naad (@teopl)
#  Art, Music, Story Copyright (C) 2019 Branho (@brando464)
#
#  Contact: teopl.the.game@gmail.com
#
# Developed for the CPCRetrodev contest 2019 edition.
#
#------------------------------------------------------------------------------

# include
source $(dirname $0)/bash_library.sh

echo

echo "${COLOR_YELLOW}*** CONVERT: Asset conversion script${COLOR_NORMAL}"

echo

ARKOS_VERSION=2

# ---

FOLDER_ASSETS_INPUT_SPRITES="../assets/sprites"
FOLDER_ASSETS_INPUT_LEVELSETS="../assets/levelsets"
FOLDER_ASSETS_INPUT_SOUND="../assets/sound/arkos${ARKOS_VERSION}"
FOLDER_ASSETS_INPUT_TEXT="../assets/text"

FOLDER_ASSETS_OUTPUT_SPRITES="../src/assets/sprites"
FOLDER_ASSETS_OUTPUT_LEVELSETS="../src/assets/levelsets"
FOLDER_ASSETS_OUTPUT_SOUND1="../src/assets/sound"
FOLDER_ASSETS_OUTPUT_SOUND2="../src/assets/songs"
FOLDER_ASSETS_OUTPUT_TEXT="../src/assets/text"

#rm -rf $FOLDER_ASSETS_OUTPUT

for f in $(find ${FOLDER_ASSETS_INPUT_LEVELSETS} -type f -iname '*.rgas'); do
    ./update_levelsets.sh "${FOLDER_ASSETS_INPUT_SPRITES}/blocks.rgas" "${f}"
done

echo

./convert_sprites.sh ${FOLDER_ASSETS_INPUT_SPRITES} ${FOLDER_ASSETS_OUTPUT_SPRITES}
if [ $? -ne 0 ]; then
    exit 1
fi

./convert_levelsets.sh ${FOLDER_ASSETS_INPUT_LEVELSETS} ${FOLDER_ASSETS_OUTPUT_LEVELSETS}
if [ $? -ne 0 ]; then
    exit 1
fi

./convert_arkos.sh ${FOLDER_ASSETS_INPUT_SOUND} ${FOLDER_ASSETS_OUTPUT_SOUND1} ${FOLDER_ASSETS_OUTPUT_SOUND2}
if [ $? -ne 0 ]; then
    exit 1
fi

./convert_text.sh ${FOLDER_ASSETS_INPUT_TEXT} ${FOLDER_ASSETS_OUTPUT_TEXT}
if [ $? -ne 0 ]; then
    exit 1
fi
