#!/bin/bash

#-----------------------------LICENSE NOTICE-----------------------------------
#     __    __  ______  __________
#    / /   / / / / __ \/  _/ ____/
#   / /   / / / / / / // // /
#  / /___/ /_/ / /_/ // // /___
# /_____/\____/_____/___/\____/
# (break the loop)
#
# This file is part of Amstrad CPC game "LUDIC break the loop".
#
#  "LUDIC break the loop" is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  "LUDIC break the loop" is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with this program.  If not, see <http:#www.gnu.org/licenses/>.
#
#  Code, Concept, Story Copyright (C) 2019 Naad (@teopl)
#  Art, Music, Story Copyright (C) 2019 Branho (@brando464)
#
#  Contact: teopl.the.game@gmail.com
#
# Developed for the CPCRetrodev contest 2019 edition.
#
#------------------------------------------------------------------------------

declare -a REQUIRED_COMMANDS=("xxd" "bc" "csplit" "perl" "convert" "curl")

EXE_PREFIX=""
if [[ "$OSTYPE" == "linux-gnu" ]]; then
	CMD_CUT="cut"
	CMD_WC="wc"
	CMD_CSPLIT="csplit"
	CMD_BASE64="base64"
	CMD_SED="sed"
	CMD_MONO="mono"
	CMD_WINE="wine"
	REQUIRED_COMMANDS+=('cut' 'wc' 'csplit' 'base64' 'sed' 'mono' 'wine')
elif [[ "$OSTYPE" == "darwin"* ]]; then
	CMD_CUT="gcut"
	CMD_WC="gwc"
	CMD_CSPLIT="gcsplit"
	CMD_BASE64="gbase64"
	CMD_SED="gsed"
	CMD_MONO="wine"
	CMD_WINE="wine"
	REQUIRED_COMMANDS+=('gcut' 'gwc' 'gcsplit' 'gbase64' 'gsed' 'mono' 'wine')
elif [[ "$OSTYPE" == "cygwin" ]]; then
	CMD_CUT="cut"
	CMD_WC="wc"
	CMD_CSPLIT="csplit"
	CMD_BASE64="base64"
	CMD_SED="sed"
	CMD_MONO=""
	CMD_WINE=""
	REQUIRED_COMMANDS+=('cut' 'wc' 'csplit' 'base64' 'sed')
else
	echo "${COLOR_RED}*** CONVERT: OS ${OSTYPE} not supported!${COLOR_NORMAL}"; exit 1;
fi

# check for commands
for i in "${REQUIRED_COMMANDS[@]}"; do
	command -v ${i} >/dev/null 2>&1 || echo "${COLOR_RED}*** CONVERT: Missing ${i} command!${COLOR_NORMAL}"
	command -v ${i} >/dev/null 2>&1 || exit 1
done

export CMD_CUT CMD_WC CMD_CSPLIT CMD_BASE64 CMD_SED CMD_MONO CMD_WINE
