//-----------------------------LICENSE NOTICE-----------------------------------
//     __    __  ______  __________
//    / /   / / / / __ \/  _/ ____/
//   / /   / / / / / / // // /
//  / /___/ /_/ / /_/ // // /___
// /_____/\____/_____/___/\____/
// (break the loop)
//
// This file is part of Amstrad CPC game "LUDIC break the loop".
//
//  "LUDIC break the loop" is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  "LUDIC break the loop" is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
//  Code, Concept, Story Copyright (C) 2019 Naad (@teopl)
//  Art, Music, Story Copyright (C) 2019 Branho (@brando464)
//
//  Contact: teopl.the.game@gmail.com
//
// Developed for the CPCRetrodev contest 2019 edition.
//
//------------------------------------------------------------------------------

#ifdef DEBUG

#include <types.h>

#include "teopl_util.h"
#include "teopl_defines.h"

#include "assets/sprites/font.h"

#ifndef _TEOPL_DEBUG_H_
#define _TEOPL_DEBUG_H_

#define TEOPL_DEBUG_PRINT(MSG) teopl_debug_print(MSG)

#define TEOPL_DEBUG_PRINT_X_B                   8
#define TEOPL_DEBUG_PRINT_Y_PX                  4

#define TEOPL_DEBUG_INFO_LINE_KEY_NUM_BYTES     6
#define TEOPL_DEBUG_INFO_LINE_VALUE_NUM_BYTES   5

#define TEOPL_DEBUG_INFO_LINE_KEY_W_B           (TEOPL_DEBUG_INFO_LINE_KEY_NUM_BYTES * font_WIDTH_B)
#define TEOPL_DEBUG_INFO_LINE_VALUE_W_B         (TEOPL_DEBUG_INFO_LINE_VALUE_NUM_BYTES * font_WIDTH_B)

#define TEOPL_DEBUG_INFO_LINE_VALUE_X_B         (TEOPL_DEBUG_PRINT_X_B + TEOPL_DEBUG_INFO_LINE_KEY_W_B + font_WIDTH_B)

#define TEOPL_DEBUG_PRINT_W_B                   (TEOPL_DEBUG_INFO_LINE_KEY_W_B + font_WIDTH_B + TEOPL_DEBUG_INFO_LINE_VALUE_W_B)

#define TEOPL_DEBUG_INFO_LINE_NUM_BYTES         (TEOPL_UTIL_MAX(TEOPL_DEBUG_INFO_LINE_KEY_NUM_BYTES, TEOPL_DEBUG_INFO_LINE_VALUE_NUM_BYTES) + 3)

typedef enum {
    TEOPL_DEBUG_SHOW_TYPE_NONE,

    TEOPL_DEBUG_SHOW_TYPE_REFRESH,
    TEOPL_DEBUG_SHOW_TYPE_ON_CHANGE,

    _TEOPL_DEBUG_SHOW_TYPE_NUM
} TeoplDebugShowType;

typedef enum {

    TEOPL_DEBUG_VALUE_SIZE_8,
    TEOPL_DEBUG_VALUE_SIZE_16,
    TEOPL_DEBUG_VALUE_SIZE_32

} TeoplDebugValueSize;

extern TeoplDebugShowType   g_teopl_debug_show;

extern u16                  g_teopl_debug_time_start[8];
extern u16                  g_teopl_debug_time_end[8];
extern u16                  g_teopl_debug_time_diff[8];

extern u8                   g_teopl_debug1_u8;
extern u8                   g_teopl_debug2_u8;
extern u16                  g_teopl_debug_u16;
extern u32                  g_teopl_debug_u32;

// ---

void teopl_debug_init();

void teopl_debug_draw();
void teopl_debug_print(char* message);
void teopl_debug_print_u32(char* message, u32* value, TeoplDebugValueSize type, u8 num);
void teopl_debug_toggle();

#endif // _TEOPL_DEBUG_H_

#else

#define TEOPL_DEBUG_PRINT(MSG)

#endif // DEBUG
